/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0precise-20140920-0115/msg/DeviceSensor.msg
 *
 */


#ifndef JSK_GUI_MSGS_MESSAGE_DEVICESENSOR_H
#define JSK_GUI_MSGS_MESSAGE_DEVICESENSOR_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace jsk_gui_msgs
{
template <class ContainerAllocator>
struct DeviceSensor_
{
  typedef DeviceSensor_<ContainerAllocator> Type;

  DeviceSensor_()
    : temperature(0.0)
    , relative_humidity(0.0)
    , light(0.0)
    , pressure(0.0)
    , proximity(0.0)  {
    }
  DeviceSensor_(const ContainerAllocator& _alloc)
    : temperature(0.0)
    , relative_humidity(0.0)
    , light(0.0)
    , pressure(0.0)
    , proximity(0.0)  {
    }



   typedef double _temperature_type;
  _temperature_type temperature;

   typedef double _relative_humidity_type;
  _relative_humidity_type relative_humidity;

   typedef double _light_type;
  _light_type light;

   typedef double _pressure_type;
  _pressure_type pressure;

   typedef double _proximity_type;
  _proximity_type proximity;




  typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct DeviceSensor_

typedef ::jsk_gui_msgs::DeviceSensor_<std::allocator<void> > DeviceSensor;

typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensor > DeviceSensorPtr;
typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensor const> DeviceSensorConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_gui_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'jsk_gui_msgs': ['/tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0precise-20140920-0115/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d3861ba768b988b4c249337d4dc6552d";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd3861ba768b988b4ULL;
  static const uint64_t static_value2 = 0xc249337d4dc6552dULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_gui_msgs/DeviceSensor";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 temperature\n\
float64 relative_humidity\n\
float64 light\n\
float64 pressure\n\
float64 proximity\n\
\n\
\n\
\n\
";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.temperature);
      stream.next(m.relative_humidity);
      stream.next(m.light);
      stream.next(m.pressure);
      stream.next(m.proximity);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct DeviceSensor_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_gui_msgs::DeviceSensor_<ContainerAllocator>& v)
  {
    s << indent << "temperature: ";
    Printer<double>::stream(s, indent + "  ", v.temperature);
    s << indent << "relative_humidity: ";
    Printer<double>::stream(s, indent + "  ", v.relative_humidity);
    s << indent << "light: ";
    Printer<double>::stream(s, indent + "  ", v.light);
    s << indent << "pressure: ";
    Printer<double>::stream(s, indent + "  ", v.pressure);
    s << indent << "proximity: ";
    Printer<double>::stream(s, indent + "  ", v.proximity);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_GUI_MSGS_MESSAGE_DEVICESENSOR_H
